/***************************************************************************
 *             __________               __   ___
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 *
 * Copyright (C) 2014 by Ilia Sergachev: Initial Rockbox port to iBasso DX50
 * Copyright (C) 2014 by Mario Basister: iBasso DX90 port
 * Copyright (C) 2014 by Simon Rothen: Initial Rockbox repository submission, additional features
 * Copyright (C) 2014 by Udo Schläpfer: Code clean up, additional features
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/


#ifndef _GOVERNOR_IBASSO_H_
#define _GOVERNOR_IBASSO_H_


/* Supported freq scaling governors. */
enum ibasso_governors
{
    /* Slow frequency switching. */
    GOVERNOR_CONSERVATIVE = 0,

    /* Fast frequency switching. */
    GOVERNOR_ONDEMAND,
    GOVERNOR_INTERACTIVE,

    /* Allways lowest frequency. */
    GOVERNOR_POWERSAVE,

    /* Allways highest frequency. */
    GOVERNOR_PERFORMANCE
};


/*
    Set the active freq scaling governor.
    governor: ibasso_governors
*/
void ibasso_set_governor(int governor);


#endif
